<template>
  <div class="circle-details">
    <div v-if="!circle">
      <v-progress-circular
        :size="50"
        color="primary"
        indeterminate
      ></v-progress-circular>
    </div>
    <header class="circle-details-header">
      <picture class="image">
        <source
          media="(min-width:650px)"
          v-if="circle && circle.imageUrl"
          :srcset="circle && circle.imageUrl"
        />
        <img alt="Circle Header" class="banner-image" />
      </picture>
    </header>
    <div class="details">
      <v-container>
        <v-row justify="center">
          <v-col lg="10" md="10" sm="10" xs="12">
            <v-card max-height="400" tile>
              <v-img
                v-if="circle && circle.imageUrl"
                :src="circle && circle.imageUrl"
                tile
                aspect-ratio="1"
                class="white--text align-end"
                max-height="400"
                gradient="to bottom, rgba(0,0,0,0), rgba(0,0,0,0.1), rgba(0,0,0,0.2)"
              >
                <v-card-text>
                  <p class="body font-weight-bold pa-1 white--text">
                    {{ circle.circleType | capitalize }}
                  </p>
                  <p class="display-1 font-weight-bold pa-1 white--text">
                    {{ circle.title | capitalize }}
                  </p>
                  <p class="subtitle-1 font-weight-bold pa-1 white--text">
                    <v-icon color="#fff" class="mr-2">mdi-calendar</v-icon
                    >{{
                      circle &&
                        circle.dateItem &&
                        circle.dateItem.date | moment('MM/DD/YY')
                    }}
                  </p>
                  <p class="subtitle-1 font-weight-bold pa-1 white--text">
                    <v-icon color="#fff" class="mr-2">mdi-map-marker</v-icon
                    >Virtual event
                  </p>
                </v-card-text>
              </v-img>
            </v-card>
            <v-row no-gutters style="box-shadow: 0 1px 2px 0 rgba(0,0,0,0.15)">
              <v-col xs="12" md="8" class="pt-0">
                <v-tabs
                  color="#333"
                  background-color="#fff"
                  center-active
                  fixed-tabs
                >
                  <v-tab @click="scrollTo('description')">Description</v-tab>
                  <v-tab @click="scrollTo('dateTime')">Date and time</v-tab>
                  <v-tab @click="scrollTo('aboutHost')">About the host</v-tab>
                </v-tabs>
                <!--                  <v-tab-item-->
                <!--                    >-->
                <div id="description" class="pb-6 pa-10 tabItem">
                  <p class="title">Description</p>
                  <p class="pr-10 body-1">
                    {{ circle && circle.description }}
                  </p>
                  <p class="body-1">
                    <b>Group Size:</b> up to
                    {{ circle.numOfParticipants }}
                  </p>
                  <div class="pt-2">
                    <v-chip
                      v-for="(label, index) in circle.labels"
                      :key="index"
                      outlined
                      class="mr-2 body-1"
                      >{{ label }}</v-chip
                    >
                  </div>
                </div>
                <!--                  </v-tab-item-->
                <!--                  >-->
                <!--                  <v-tab-item>-->
                <div id="dateTime" class="pb-10 pa-10 tabItem">
                  <p class="title">Date and time</p>
                  <p class="body-1">
                    <b>On:</b>
                    {{
                      circle &&
                        circle.dateItem &&
                        circle.dateItem.date | moment('MM/DD/YY')
                    }}
                    at
                    {{
                      circle &&
                        circle.dateItem &&
                        circle.dateItem.time | moment('LT')
                    }}
                  </p>
                  <p class="body-1">
                    <b>Duration:</b>
                    {{
                      circle.sessionDuration &&
                        circle.sessionDuration.hr * 60 +
                          circle.sessionDuration.min
                    }}
                    minutes
                  </p>
                  <p class="body-1">
                    <b>Frequency:</b> every
                    {{ circle.frequency && circle.frequency.number }}
                    {{ circle.frequency && circle.frequency.type }}
                  </p>
                </div>
                <!--                  </v-tab-item-->
                <!--                  >-->
                <!--                  <v-tab-item>-->
                <div id="aboutHost" class="pb-10 pa-10 tabItem">
                  <p class="title">About the host</p>
                  <v-card elevation="0">
                    <v-list-item>
                      <v-list-item-avatar color="grey darken-3">
                        <v-btn
                          :to="
                            `/facilitators/${circle.facilitator &&
                              circle.facilitator.firstName}/${
                              circle.facilitatorId
                            }`
                          "
                        >
                          <v-avatar>
                            <v-img
                              v-if="
                                circle.facilitator &&
                                  circle.facilitator.imageUrl
                              "
                              :src="
                                circle.facilitator &&
                                  circle.facilitator.imageUrl
                              "
                            ></v-img>
                          </v-avatar>
                        </v-btn>
                      </v-list-item-avatar>
                      <v-list-item-content>
                        <v-list-item-title class="title">{{
                          circle.facilitator &&
                            circle.facilitator.firstName +
                              ' ' +
                              circle.facilitator.lastName
                        }}</v-list-item-title>
                        <v-list-item-subtitle>{{
                          circle.facilitator && circle.facilitator.title
                        }}</v-list-item-subtitle>
                      </v-list-item-content>
                    </v-list-item>
                    <v-card-text>
                      {{ circle.facilitator && circle.facilitator.about }}
                    </v-card-text>
                  </v-card>
                </div>
                <!--                  </v-tab-item>-->
                <!--                </v-tabs>-->
              </v-col>
              <v-col class="pt-0">
                <v-card tile>
                  <v-card-text>
                    <p style="display: flex; justify-content: space-between;">
                      <span class="title">Price</span>
                      <span class="title font-weight-bold"
                        >${{ circle.price }}</span
                      >
                    </p>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-text class="text-center">
                    <AuthDialog v-if="!user" />
                    <v-btn
                      v-if="user"
                      color="red lighten-2"
                      outlined
                      dark
                      :to="`/book/${circle.title}/${circle.id}`"
                      >Join this circle</v-btn
                    >
                  </v-card-text>
                </v-card>
                <div class="pt-5 text-center body-1">
                  <ShareNetwork
                    network="facebook"
                    :url="circleUrl"
                    :title="circle.title ? circle.title : 'Circle group'"
                    :description="circle && circle.description"
                    quote="As human beings, we share a common thread."
                    hashtags="facilitation,circle,health"
                  >
                    <span>
                      <v-icon left color="primary">mdi-share-variant</v-icon>
                      Share circle
                    </span>
                  </ShareNetwork>
                </div>
              </v-col>
            </v-row>
            <v-row>
              <v-col xs="12">
                <p v-if="typeCircles && typeCircles.length > 0" class="title">
                  Similar circles...
                </p>
              </v-col>
            </v-row>
            <v-row v-if="typeCircles && typeCircles.length > 0">
              <v-col
                v-for="circle in typeCircles"
                :key="circle.title"
                xs="12"
                md="4"
                lg="3"
              >
                <circle-item :circle="circle" />
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </v-container>
    </div>
  </div>
</template>

<script>
import AuthDialog from '@/components/Shared/Auth/AuthDialog'
import CircleItem from '@/components/Circle/CircleItem'
import { mapActions, mapState } from 'vuex'
import router from '@/router'

export default {
  components: {
    AuthDialog,
    CircleItem
  },
  data: () => ({}),
  head() {
    return {
      title: {
        inner: 'Circle Details'
      }
    }
  },
  computed: {
    ...mapState('circle', ['circle', 'typeCirclesTerms']),
    ...mapState('authentication', ['user']),
    circleUrl() {
      return `circlelarity.com${this.$router.currentRoute.fullPath}`
    },
    typeCircles() {
      const circles = []
      this.$store.state.circle.typeCircles.forEach((circle, index) => {
        if (index < 3) {
          circles.push(circle)
        }
      })
      return circles
      // return this.$store.state.circle.typeCircles
    }
  },
  destroyed() {
    this.$store.commit('circle/setCircle', null, { root: true })
  },
  beforeMount() {
    if (this.$route.params.id) {
      this.$store
        .dispatch('circle/getCircle', this.$route.params.id)
        .then(() => {
          if (this.circle.circleType) {
            this.getTypeCircles()
          }
        })
    } else {
      router.push('/')
    }
  },
  created() {},
  methods: {
    ...mapActions('circle', ['getCircle']),
    getTypeCircles() {
      const typeCirclesTerms = {
        circleType: this.circle.circleType,
        exceptId: this.circle.id,
        limit: 3
      }
      this.$store.commit('circle/addTypeCirclesTerms', typeCirclesTerms)
      this.$store.dispatch('circle/getTypeCircles', typeCirclesTerms)
    },
    scrollTo(element) {
      const el = document.getElementById(element)
      el.scrollIntoView({behavior: "smooth", block: "center", inline: "nearest"})
    }
  }
}
</script>

<style lang="scss" scoped>
.circle-details {
  .circle-details-header {
    position: absolute;
    top: 61px;
    width: 100%;
    height: 66vh;
    max-height: inherit;
    min-height: 474px;
    overflow: hidden;
    .image {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
    }
    .banner-image {
      -webkit-transform: translate(-50%, -50%);
      -moz-transform: translate(-50%, -50%);
      -ms-transform: translate(-50%, -50%);
      -o-transform: translate(-50%, -50%);
      transform: translate(-50%, -50%);
      -webkit-filter: blur(50px) brightness(0.9);
      -ms-filter: blur(50px) brightness(0.9);
      filter: blur(30px) brightness(0.8);
      display: inline-block;
      width: 200%;
      position: relative;
      top: 50%;
      left: 50%;
    }
  }
  .details {
    position: relative;
  }
  .tabItem {
    background-color: white;
  }
}
</style>
